2011年9月18日日曜日

Codeforces Beta Round #87 Div. 1 Only

Codeforces Beta Round #86 Div. 1 Only (9/16 0:00~2:00)

■A. Party

解法

グラフに注目したとき下のような列があったとする.
A1->A2->…->AN
この列の中の任意の2ノードは, 同じグループに属することができないため, 最低でもNグループ必要だと分かる.
このようなNの中で最大のものNmaxを見つければ, 任意の列は,長さが高々Nmaxなので, Nmax個のグループに高々1人で振り分けることが出来る.
結局,Nmaxが答え.
#86 Div. 1 A. Party

■B. Lawnmower

解法

ジグザグに進んでいくため,貪欲に求めることが出来る.
#86 Div. 1 B. Lawnmower

■Result

oo--- 1146pts. 256th
1700→1717

2011年9月11日日曜日

Codeforces Beta Round #86 Div. 1 Only

Codeforces Beta Round #86 Div. 1 Only (9/9 0:00~2:00)

■A. A Grammar Lessons

問題

Petyaの作った言語は以下のBNFにより定義される.与えられた文字列がSentenceか判定せよ.

Sentence := Statement | AdjectiveM | AdjectiveF | NounM | NounF | VerbM | VerbF
Statement := (AdjectiveM* NounM VerbM*) | (AdjectiveF* NounF VerbF*)

AdjectiveM := "lios" | Alphabet AdjectiveM
AdjectiveF := "liala" | Alphabet AdjectiveF
NounM := "etr" | Alphabet NounM
NounF := "etra" | Alphabet NounF
VerbM := "initis" | Alphabet VerbM
VerbF := "inites" | Alphabet VerbF

Alphabet := "a"|"b"|"c"|…|"z"

解法

書くだけ.StatementのBNFをDFAにしてからコードにすると,機械的に解ける.
#86 Div. 1 A. A Grammar Lessons

■B. Petr#

問題

文字列s,sbegin,sendが与えられる.
以下を満たす文字列tの個数を求めよ.
  • tはsの部分文字列
  • sbeginはtのprefix
  • sendはtのsuffix

解法

sにおいて,sbeginおよびsendを検索して,インデックスの候補を列挙する.
sbegin,sendに関するインデックスks,keについて,
s[ks]からsbeginがあり,
s[ke]からsendがあり,
ks≦ke かつ ks+|sbegin|≦ke+|send|
ならば,
s[ks],…,s[ke],…,s[ke+|send|-1]
が条件を満たす文字列.
条件を満たす文字列を逐一生成すると,TLEするので,
ハッシュを計算し,重複要素を取り除くことで高速化.
#86 Div. 1 B. Petr#

■Result

o---- 254pts. 215th
1684->1700

TopCoder SRM 517

TopCoder SRM 517 (9/11 1:00~3:00)

■CompositeSmash(Easy)

問題

ある数xをy≧2,z≧2,yz=xを満たす2つの数に分割する.
この分割操作を再帰的に繰り返す.
e.g., x=12ならば,(y,z)=(3,4) or (2,6)など.
1や素数は,それ以上分割できない.

初期値としてNが与えられる.
Nを任意の方法で分割していき, 全ての分割が終了するまでにtargetが出現するかを判定せよ.

解法

全探索.念の為メモ化もしたが,無くても通る様子.
SRM 517 Div. 1 Easy CompositeSmash

■Result

o-- +0/-0
191.33pts. 301th

■Rating

1645->1673

2011年9月4日日曜日

Codeforces Beta Round #85 Div. 1 Only

Codeforces Beta Round #85 Div. 1 Only (9/4 21:00~23:00)

■A. Petya and Inequiations

問題

n,x,yが与えられる.
a12+a22+…+an2≥x
a1+a2+…+an≤y
を満たす正整数の列
a1,a2,…,an
を求めよ.なければ,-1を返せ.

解法

a1+a2+…+an
の最小値はn.次に,
a1+a2+…+an=y
としたとき,
a12+a22+…+an2
の最大値は,
ak=1 (1≤k≤n-1)
an=y-(n-1)
のとき,この値(=(n-1)+(y-(n-1))2)がx以上なら数列(ak)が答え.
#85 Div. 1 A. Petya and Inequiations

■B. Petya and Divisors

問題

2つの数列
x1,…,xn
y1,…,yn
が与えられる.
各(xi, yi)について,
xi mod k=0 かつ (∀j:i-yi≤j<i) xj mod k ≠ 0
なる正整数kの数を求めよ.

解法

xiの各約数di,kについて,
それがx1,…,xi-1の約数である最後のインデックスp[di,k]を記録しておく.
p[di,k]<i-yiなら条件を満たす.
その後,
p[di,k]=i
と更新.
#85 Div. 1 B. Petya and Divisors

■Result

o---- 484pts. 278th
1689 -> 1684

ドカーン.

2011年9月3日土曜日

TopCoder SRM 513

TopCoder SRM 516(8/31 0:00~2:00)

敗北.

■NetworkXOneTimePad(Easy)

・解法

全探索.
Long.parseLong(str, 2)をLong.parseLong(str)と書いてしまい,終了数分前に直すはめになってしまった.

■Challenge Phase

TLEが狙えるかと思ったが撃墜失敗. むしろ,サンプルの弱さを考慮した撃墜を作っておくべきだった.

■Result

o-- +0/-1
50.0pts. 489th

■Rating

1727 -> 1645
捻挫+打撲.

Codeforces Beta Round #84 Div. 2 Only

Codeforces Beta Round #84 Div. 2 Only 8/30 1:00~3:00)

■A. Nearly Lucky Number

問題

Lucky Digitを,4または7として定義する.
Lucky Numberは,Lucky Digitのみで表現される(10進)数のことである.
Nearly Lucky Numberとは,ある数に含まれるLucky Digitの個数が,Lucky Numberである数のことである.
与えられた数が,Nearly Lucky Numberかどうかを判定せよ.

解法

やるだけ.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class A{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     void run(){  
  16.         long n=sc.nextLong();  
  17.         int c=0;  
  18.         for(; n>0; n/=10){  
  19.             if(n%10==4||n%10==7){  
  20.                 c++;  
  21.             }  
  22.         }  
  23.         boolean f=c>0;  
  24.         for(; c>0; c/=10){  
  25.             f&=c%10==4||c%10==7;  
  26.         }  
  27.         println(f?"YES":"NO");  
  28.     }  
  29.   
  30.     void println(String s){  
  31.         System.out.println(s);  
  32.     }  
  33.   
  34.     void print(String s){  
  35.         System.out.print(s);  
  36.     }  
  37.   
  38.     void debug(Object... os){  
  39.         System.err.println(Arrays.deepToString(os));  
  40.     }  
  41.   
  42.     public static void main(String[] args){  
  43.         new A().run();  
  44.     }  
  45. }  

■B. Lucky String

問題

Lucky Stringとは, ある文字列において出現するアルファベットのインデックスをアルファベット毎に分類・ソートしたときに, 隣り合うインデックスの差がLucky Numberである文字列のことである.
長さnのLucky Stringの内,辞書式順で最も早いものを出力せよ.

解法

abcdabcd…
↑これをn文字出力するだけ.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class B{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     void run(){  
  16.         int n=sc.nextInt();  
  17.         StringBuffer sb=new StringBuffer("");  
  18.         for(int i=0; i<n;){  
  19.             for(char c='a'; c<='d'&&i<n; c++, i++){  
  20.                 sb.append(c);  
  21.             }  
  22.         }  
  23.         println(sb.toString());  
  24.     }  
  25.   
  26.     void println(String s){  
  27.         System.out.println(s);  
  28.     }  
  29.   
  30.     void print(String s){  
  31.         System.out.print(s);  
  32.     }  
  33.   
  34.     void debug(Object... os){  
  35.         System.err.println(Arrays.deepToString(os));  
  36.     }  
  37.   
  38.     public static void main(String[] args){  
  39.         new B().run();  
  40.     }  
  41. }  

■C. Lucky Sum of Digits

問題

各桁の総和がnとなる最小のLucky Numberを求めよ.

解法

4の個数と,7の個数が固定ならば,
44…4477…77
という形のLucky Numberが最小であることは明らか.
次に,4の個数をa,7の個数をbとすると,
4a+7b=n
が成立する.
(例えば28で考えれば分かるが) 上の条件を満たす(a, b)の中で,bが最大ものが最小のLucky Numberとなることは明らか.
従って,aを0から逐次増やしていき, (n-4a) mod 7=0となればそこで計算を終了すればいい.
そのようなaが見つからずにループが終了したときは,条件を満たすLucky Numberは存在しない.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class C{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     int n;  
  16.   
  17.     void run(){  
  18.         n=sc.nextInt();  
  19.         for(int a=0; n-4*a>=0; a++){  
  20.             if((n-4*a)%7==0){  
  21.                 int b=(n-4*a)/7;  
  22.                 StringBuffer sb=new StringBuffer();  
  23.                 for(int i=0; i<a; i++){  
  24.                     sb.append('4');  
  25.                 }  
  26.                 for(int i=0; i<b; i++){  
  27.                     sb.append('7');  
  28.                 }  
  29.                 println(sb.toString());  
  30.                 return;  
  31.             }  
  32.         }  
  33.         println("-1");  
  34.     }  
  35.   
  36.     void println(String s){  
  37.         System.out.println(s);  
  38.     }  
  39.   
  40.     void print(String s){  
  41.         System.out.print(s);  
  42.     }  
  43.   
  44.     void debug(Object... os){  
  45.         System.err.println(Arrays.deepToString(os));  
  46.     }  
  47.   
  48.     public static void main(String[] args){  
  49.         new C().run();  
  50.     }  
  51. }  

■E. Lucky Tree

問題

ノード数n,辺の数n-1の非循環無向グラフ(=全域木)が与えられる.
各辺には,重みがついている.
次の条件を満たす3つ組(i,j,k)の数を求めよ.
  • iからjの経路にはLucky Numberを重みとして持つ辺が少なくとも1つある.
  • iからkの経路にはLucky Numberを重みとして持つ辺が少なくとも1つある.

解法

例えば,グラフが以下のようなものだったとする.
ここで,点線になっている辺は,Lucky Numberの重みを持つ.
ポイントは,上の条件を満たさない3つ組みを求める方が簡単だということ.
例えば,グループ1に注目してみる.
グループ1から選んだ3ノードより構成される3つ組み (v1,v2,v3)は,決して上の条件を満たさない.
また,グループ1から2ノード(v1,v2とする)を選び, グループ1以外の任意の1ノード(uとする)を選んだとき,
(v1,v2,u),(v1,u,v2)
も上の条件を満たさない.
つまり,あるグループkがmノードから構成されているとすれば,
m(m-1)(m-2)+2m(m-1)(n-m)
が,グループkのノードを2つ以上含みかつ上の条件を満たさ「ない」3つ組みの総数となる.
全てのグループについて上式の和を計算したものをsumとする.
最後に,nノードから3つ選ぶ順列の総数はn(n-1)(n-2)であるから,
n(n-1)(n-2)-sumが答えとなる.
さて,どうやってグラフ構造をグループに分け,そのグループのノード数を計算するだが, これについては,Union-Findを用いるのがスマートだと思われる.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class E{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     int n;  
  16.   
  17.     void run(){  
  18.         n=sc.nextInt();  
  19.         make(n);  
  20.   
  21.         for(int i=0; i<n-1; i++){  
  22.             int u=sc.nextInt()-1;  
  23.             int v=sc.nextInt()-1;  
  24.             int w=sc.nextInt();  
  25.             if(!isLucky(w)){  
  26.                 union(u, v);  
  27.             }  
  28.         }  
  29.   
  30.         debug(p);  
  31.   
  32.         long ans=0;  
  33.         for(int i=0; i<n; i++){  
  34.             long s=size(i);  
  35.             if(p[i]>=0){  
  36.                 continue;  
  37.             }  
  38.             if(s>=3){  
  39.                 ans+=s*(s-1)*(s-2);  
  40.             }  
  41.             if(s>=2){  
  42.                 ans+=s*(s-1)*(n-s)*2;  
  43.             }  
  44.         }  
  45.   
  46.         // debug(n*(n-1)*(n-2));  
  47.         // debug(ans);  
  48.         ans=(long)n*(n-1)*(n-2)-ans;  
  49.         println(ans+"");  
  50.     }  
  51.   
  52.     boolean isLucky(int n){  
  53.         for(; n>0; n/=10){  
  54.             if(n%10!=4&&n%10!=7){  
  55.                 return false;  
  56.             }  
  57.         }  
  58.         return true;  
  59.     }  
  60.   
  61.     int[] p;  
  62.   
  63.     void make(int n){  
  64.         p=new int[n];  
  65.         fill(p, -1);  
  66.     }  
  67.   
  68.     int find(int x){  
  69.         return p[x]<0?x:(p[x]=find(p[x]));  
  70.     }  
  71.   
  72.     boolean union(int x, int y){  
  73.         x=find(x);  
  74.         y=find(y);  
  75.         if(x!=y){  
  76.             if(p[y]<p[x]){  
  77.                 int t=x;  
  78.                 x=y;  
  79.                 y=t;  
  80.             }  
  81.             p[x]+=p[y];  
  82.             p[y]=x;  
  83.         }  
  84.         return x!=y;  
  85.     }  
  86.   
  87.     int size(int x){  
  88.         return -p[find(x)];  
  89.     }  
  90.   
  91.     void println(String s){  
  92.         System.out.println(s);  
  93.     }  
  94.   
  95.     void print(String s){  
  96.         System.out.print(s);  
  97.     }  
  98.   
  99.     void debug(Object... os){  
  100.         System.err.println(Arrays.deepToString(os));  
  101.     }  
  102.   
  103.     public static void main(String[] args){  
  104.         new E().run();  
  105.     }  
  106. }  

■Result

ooo-o 4068pts. 27th
1631 -> 1689

Codeforces Beta Round #83 Div. 2 Only

Codeforces Beta Round #83 Div. 2 Only 8/24 0:00~2:00)

■A. Palindromic Times

問題

デジタル時計の時刻が与えられる(HH:MMの形式).
その時刻以降で,時刻が回文になるものを求めよ.

解法

高々24x60回の計算で終わるので,逐一試す.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class A{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     void run(){  
  16.         String[] ss=sc.next().split(":");  
  17.         int h=Integer.parseInt(ss[0]);  
  18.         int m=Integer.parseInt(ss[1]);  
  19.         for(;;){  
  20.             if(++m==60){  
  21.                 m=0;  
  22.                 if(++h==24){  
  23.                     h=0;  
  24.                 }  
  25.             }  
  26.             String s=String.format("%02d:%02d", h, m);  
  27.             if(new StringBuffer(s).reverse().toString().equals(s)){  
  28.                 println(s);  
  29.                 return;  
  30.             }  
  31.         }  
  32.     }  
  33.   
  34.     void println(String s){  
  35.         System.out.println(s);  
  36.     }  
  37.   
  38.     void print(String s){  
  39.         System.out.print(s);  
  40.     }  
  41.   
  42.     void debug(Object... os){  
  43.         System.err.println(Arrays.deepToString(os));  
  44.     }  
  45.   
  46.     public static void main(String[] args){  
  47.         new A().run();  
  48.     }  
  49. }  

■C. Dorm Water Supply

問題・解法

ある有向グラフが与えられる.
頂点には,多くとも1つの入る/出る辺があり,辺には情報として容量が与えられる.
以下を満たす(頂点V,頂点U,容量C)を求めよ.
  • Vには入る辺がない.
  • Uには出る辺がない.
  • Vから辺を辿ることで,Uに到着する.
  • Cは,VからUに至る辺の容量で最小のもの.
問題を意訳すると以上のようになるため,あとは書くだけです.
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class C{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     int n, p;  
  16.     E[] es;  
  17.     int[] parent;  
  18.     LinkedList<E> answers;  
  19.     boolean[] visited;  
  20.   
  21.     class E{  
  22.         int from, to, cap;  
  23.   
  24.         E(int from, int to, int cap){  
  25.             this.from=from;  
  26.             this.to=to;  
  27.             this.cap=cap;  
  28.         }  
  29.     }  
  30.   
  31.     void run(){  
  32.         n=sc.nextInt();  
  33.         p=sc.nextInt();  
  34.         es=new E[n];  
  35.         answers=new LinkedList<E>();  
  36.         parent=new int[n];  
  37.         fill(parent, -1);  
  38.         for(int i=0; i<n; i++){}  
  39.         for(int i=0; i<p; i++){  
  40.             int a=sc.nextInt()-1;  
  41.             int b=sc.nextInt()-1;  
  42.             int d=sc.nextInt();  
  43.             es[a]=new E(a, b, d);  
  44.             parent[b]=a;  
  45.         }  
  46.         solve();  
  47.     }  
  48.   
  49.     void solve(){  
  50.         visited=new boolean[n];  
  51.         for(int i=0; i<n; i++){  
  52.             if(visited[i]){  
  53.                 continue;  
  54.             }  
  55.             int k=i;  
  56.             boolean loop=false;  
  57.             for(; parent[k]>=0;){  
  58.                 k=parent[k];  
  59.                 if(k==i){  
  60.                     loop=true;  
  61.                     break;  
  62.                 }  
  63.             }  
  64.             if(loop){  
  65.                 continue;  
  66.             }  
  67.             if(es[k]!=null){  
  68.                 visited[k]=true;  
  69.                 dfs(es[k].to, k, es[k].cap);  
  70.             }  
  71.         }  
  72.         E[] anss=answers.toArray(new E[0]);  
  73.         sort(anss, new Comparator<E>(){  
  74.             @Override  
  75.             public int compare(E e1, E e2){  
  76.                 return e1.from-e2.from;  
  77.             }  
  78.         });  
  79.         println(anss.length+"");  
  80.         for(E e : anss){  
  81.             println(e.from+" "+e.to+" "+e.cap);  
  82.         }  
  83.     }  
  84.   
  85.     void dfs(int v, int tank, int diameter){  
  86.         visited[v]=true;  
  87.         if(es[v]==null){  
  88.             answers.add(new E(tank+1, v+1, diameter));  
  89.             return;  
  90.         }  
  91.         dfs(es[v].to, tank, min(diameter, es[v].cap));  
  92.     }  
  93.   
  94.     void println(String s){  
  95.         System.out.println(s);  
  96.     }  
  97.   
  98.     void print(String s){  
  99.         System.out.print(s);  
  100.     }  
  101.   
  102.     void debug(Object... os){  
  103.         // System.err.println(Arrays.deepToString(os));  
  104.     }  
  105.   
  106.     public static void main(String[] args){  
  107.         new C().run();  
  108.     }  
  109. }  

■D. Basketball Team

問題

N人からなるチームを作りたい.
候補は全部でS人であり,Herr Wafaには仲間がK人いる.
S人からN人をランダムに選ぶとき,
Herr Wafaが少なくとも一人の仲間と一緒になる確率を求めよ.
N人を選べない(候補の人数が足りない)場合は-1とせよ.

解法

Herr Wafaがチームに選ばれなかった状態は省く.
(N, R)を二項係数(=N個からR個を選ぶ組み合わせの総数)とする.
Herr Wafaがチームに選ばれたとして,残りのN-1人を選ぶ方法は(S-1, N-1)通り.
その内,仲間が一人も居ない場合は(S-1-K, N-1)通り.すなわち,
1-{(S-1-K, N-1)/(S-1, N-1)}
が答え.
左の項はもっと簡単に,
(S-N)(S-N-1)…(S-N-K+1)
-----------------------
(M-1)(M-2)…(M+K)
と表せるので,ループ一つで求められる.
但し,精度が落ちないように工夫して計算する必要がある(下記コード参照).
  1. import java.util.*;  
  2. import java.lang.*;  
  3. import java.math.*;  
  4. import java.io.*;  
  5.   
  6. import static java.lang.Math.*;  
  7. import static java.util.Arrays.*;  
  8.   
  9. public class D{  
  10.     Scanner sc=new Scanner(System.in);  
  11.   
  12.     int INF=1<<28;  
  13.     double EPS=1e-9;  
  14.   
  15.     int n, m, h;  
  16.     int[] s;  
  17.   
  18.     void run(){  
  19.         n=sc.nextInt();  
  20.         m=sc.nextInt();  
  21.         h=sc.nextInt()-1;  
  22.         s=new int[m];  
  23.         for(int i=0; i<m; i++){  
  24.             s[i]=sc.nextInt();  
  25.         }  
  26.         solve();  
  27.     }  
  28.   
  29.     void solve(){  
  30.         int sum=0;  
  31.         for(int i=0; i<m; i++){  
  32.             sum+=s[i];  
  33.         }  
  34.         if(sum<n){  
  35.             println("-1.0");  
  36.             return;  
  37.         }  
  38.         int k=s[h]-1;  
  39.         double ans=1;  
  40.         for(int i=0; i<k; i++){  
  41.             ans*=(double)(sum-n-i)/(sum-1-i);  
  42.         }  
  43.         println((1-ans)+"");  
  44.     }  
  45.   
  46.     void println(String s){  
  47.         System.out.println(s);  
  48.     }  
  49.   
  50.     void print(String s){  
  51.         System.out.print(s);  
  52.     }  
  53.   
  54.     void debug(Object... os){  
  55.         System.err.println(Arrays.deepToString(os));  
  56.     }  
  57.   
  58.     public static void main(String[] args){  
  59.         new D().run();  
  60.     }  
  61. }  

■Result

oxoo- 2816pts. 78th
1562 -> 1631
次回でDiv.1に戻れるかも知れないがしかし….